# Mathematical topics

This section of the STACK documentation contains information on how to author questions in particular mathematics topics.  Many topics have different requirements, e.g. physics needs support for scientific units.  These pages contain know-how on linking together features such as [inputs](../Authoring/Inputs.md), [answer tests](../Authoring/Answer_Tests/index.md) and [options](../Authoring/Options.md) to write questions in particular subject areas.

Current topics include:

* [GeoGebra questions](GeoGebra.md)
* [Curve sketching](Curve_sketching.md)
* [Differential equations](Differential_equations.md)
* [Discrete mathematics](Discrete_mathematics.md)
* String similarity via the [Levenshtein distance](Levenshtein_distance.md)
* [Linear algebra](Linear_algebra.md)
* [Mathematical Proof](../Proof/index.md)
* [Propositional Logic](Propositional_Logic.md)
* [Scientific Units](Units.md)
* [Vector Calculus](Vector_Calculus.md)
* [Unsorted multi-input](Unsorted_multi_input.md) questions 